// 各辺に優先度が付いている。優先度の高い辺に優先的に送る。
// 一度も使われていない辺は好きに向きを決めてよい。

#include <cstdio>
#include <vector>

#include "xrand1.h"
#include "strategy_base.hpp"

struct priority : public strategy_base {
  std::vector<int> p, C;

  priority() : p(), C() {
    scanf("%d", &N);
    A.resize(N - 1);
    B.resize(N - 1);
    p.resize(N - 1);
    C.resize(N - 1, -1);
    for (int i = 0; i < N - 1; i++) {
      scanf("%d", &A[i]);
    }
    for (int i = 0; i < N - 1; i++) {
      scanf("%d", &B[i]);
    }
    for (int i = 0; i < N - 1; i++) {
      scanf("%d", &p[i]);
    }
  }

  std::vector<int> Query(std::vector<int> x, std::vector<int> y) override {
    std::vector<std::vector<int>> g(N);
    for (int i = 0; i < N - 1; i++) {
      int a = A[i];
      int b = B[i];
      g[a].push_back(i);
      g[b].push_back(i);
    }
    std::vector<int> z(N, 0);
    for (int i = 0; i < N; i++) {
      if (!y[i])
        continue;
      int e = -1;
      for (int t : g[i]) {
        if (C[t] == -1) {
          if (e == -1 || (C[e] == -1 && p[e] < p[t])) {
            e = t;
          }
        } else {
          int a = A[t], b = B[t];
          if (C[t] ^ x[t]) {
            std::swap(a, b);
          }
          if (a == i) {
            if (e == -1 || C[e] == -1 || p[e] < p[t]) {
              e = t;
            }
          }
        }
      }
      if (e == -1) {
        z[i] = 1;
      } else {
        z[A[e] ^ B[e] ^ i] = 1;
        if (C[e] == -1) {
          C[e] = x[e] ^ (A[e] != i);
        }
      }
    }
    return z;
  }

  bool Answer(std::vector<int> a) override { return a == C; }
};
