#ifndef JOI_CONVEYOR_STRATEGY_BASE
#define JOI_CONVEYOR_STRATEGY_BASE

#include <utility>
#include <vector>

struct strategy_base {
  int N;
  std::vector<int> A, B;

  virtual std::vector<int> Query(std::vector<int> x, std::vector<int> y) = 0;
  virtual bool Answer(std::vector<int> a) = 0;

  bool is_tree() {
    std::vector<int> c(N, -1);
    const auto find = [&](int x) {
      while (c[x] >= 0)
        x = c[x];
      return x;
    };
    for (int i = 0; i < N - 1; i++) {
      if (A[i] < 0 || N <= A[i] || B[i] < 0 || N <= B[i]) {
        return false;
      }
      int a = find(A[i]), b = find(B[i]);
      if (a == b)
        return false;
      if (-c[a] < -c[b])
        std::swap(a, b);
      c[a] += c[b];
      c[b] = a;
    }
    return true;
  }
};

#endif
